var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { jsxs as _jsxs, jsx as _jsx } from "react/jsx-runtime";
import * as React from 'react';
import LoadingButton from '@mui/lab/LoadingButton';
import Stack from '@mui/material/Stack';
import Button from '@mui/material/Button';
import Alert from '@mui/material/Alert';
import ModalTitle from './Title';
import DialogContent from '@mui/material/DialogContent';
import { useConnect } from 'wagmi';
import StyledModal from './StyledModal';
import Box from '@mui/material/Box';
import { styled } from '@mui/material/styles';
import Icons from './Icons';
import useConfigFactory from '../useConfigFactory';
import { availableChains } from '../provider';
import useWebThreeAuth from '../useWebThreeAuth';
var StyledBox = styled(Box)(function (_a) {
    var theme = _a.theme;
    return ({
        border: '1px',
        borderStyle: 'solid',
        borderColor: theme.palette.background.paper,
        borderRadius: theme.shape.borderRadius,
        padding: theme.spacing(1),
        display: 'flex',
        flexDirection: 'column',
        justifyContent: 'space-between',
    });
});
export default function ConnectWalletModal() {
    var _this = this;
    var config = useConfigFactory()();
    var chain = availableChains.find(function (x) { return x.network === config.chain; });
    var _a = useConnect(), connectWagmi = _a.connect, connectors = _a.connectors, error = _a.error, isLoading = _a.isLoading, pendingConnector = _a.pendingConnector;
    var _b = useWebThreeAuth(), connectWeb3Auth = _b.connect, web3auth = _b.web3auth, pending = _b.pending;
    var _c = React.useState(false), open = _c[0], setOpen = _c[1];
    var handleOpen = function () { return setOpen(true); };
    var handleClose = function () { return setOpen(false); };
    var wagmiConnectors = connectors.map(function (connector) { return (_jsxs(LoadingButton, __assign({ fullWidth: true, variant: "outlined", disableElevation: true, disabled: !connector.ready, startIcon: Icons[connector.id], onClick: function () {
            return connectWagmi({
                connector: connector,
                chainId: chain === null || chain === void 0 ? void 0 : chain.id,
            });
        }, loading: isLoading && connector.id === (pendingConnector === null || pendingConnector === void 0 ? void 0 : pendingConnector.id) }, { children: [connector.name, !connector.ready && ' (unavailable)'] }), connector.id)); });
    var webThreeAuthConnector = (_jsxs(LoadingButton, __assign({ fullWidth: true, variant: "outlined", disableElevation: true, startIcon: Icons["torus"], disabled: !web3auth, onClick: function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                connectWeb3Auth();
                handleClose();
                return [2 /*return*/];
            });
        }); } }, { children: ["I don't have a wallet", !web3auth && ' (unavailable)'] }), void 0));
    return (_jsxs("div", { children: [_jsx(Button, __assign({ onClick: handleOpen, variant: "contained", disableElevation: true }, { children: "Connect Wallet" }), void 0), _jsxs(StyledModal, __assign({ open: open, onClose: handleClose, "aria-labelledby": "alert-dialog-title", "aria-describedby": "alert-dialog-description" }, { children: [_jsx(ModalTitle, { title: "Connect Wallet", handleClose: handleClose, disabled: false }, void 0), _jsx(DialogContent, { children: _jsxs(StyledBox, { children: [error && (_jsx(Alert, __assign({ sx: { my: 2 }, severity: "error" }, { children: error.message }), void 0)), _jsxs(Stack, __assign({ spacing: 2, p: 1 }, { children: [wagmiConnectors, webThreeAuthConnector] }), void 0)] }, void 0) }, void 0)] }), void 0)] }, void 0));
}
