import { useEffect, useState } from 'react';
import { useAccount } from 'wagmi';
import useWebThreeAuth from './useWebThreeAuth';
export default function _useAccount() {
    var webThreeAuthSigner = useWebThreeAuth().signer;
    var _a = useAccount(), wagmiAddress = _a.address, wagmiConnector = _a.connector;
    var _b = useState(undefined), address = _b[0], setAddress = _b[1];
    var _c = useState(), connector = _c[0], setConnector = _c[1];
    useEffect(function () {
        if (webThreeAuthSigner) {
            webThreeAuthSigner.getAddress().then(function (_address) {
                setAddress(_address);
                setConnector('Torus');
            });
        }
        else if (wagmiAddress && wagmiConnector) {
            setAddress(wagmiAddress);
            setConnector(wagmiConnector.name);
        }
        else {
            setAddress(undefined);
            setConnector(undefined);
        }
    }, [webThreeAuthSigner, wagmiConnector, wagmiAddress]);
    return { address: address, connector: connector };
}
